#!/bin/sh

export LC_ALL=POSIX
SYSTEMCTL=systemctl

a= . install2-init-functions

set_type_units() {
    ACTION=$1
    shift
    UNITTYPE=$1
    shift
    while [ -n "$1" ]
    do
	exec_chroot $SYSTEMCTL $ACTION ${1}.${UNITTYPE} ||:
	shift
    done
}

# set TMPDIR to /tmp/.private/LOGNAME
exec_chroot control pam_mktemp enabled ||:

# turn off tmpfs
sed -i 's|^tmpfs|#tmpfs|' $destdir/etc/fstab ||:

# turn off systemd tmp.mount
# don't mask because systemd local fs mount bug ALT#29066
#set_type_units mask mount tmp

# find free space for /tmp
BEST_SPACE=0
BEST_MP=
while read DEV MP X
do
    echo "$DEV" | grep -qe '^UUID=' || echo "$DEV" | grep -qe '^/dev/' || continue
    echo "$MP" | grep -qe '^/' || continue

    # tmpdir already configured
    if [ "$MP" == "/tmp" ]; then
	BEST_MP=
	((BEST_SPACE=0))
	break
    fi

    # check for writing
    TEST_WRITE_FILE="${destdir}/${MP}/_TEST_WRITE_"
    if touch "$TEST_WRITE_FILE"
    then
        # check for permissions
        chmod --quiet 1777 "$TEST_WRITE_FILE" \
	    || continue
	NEW_PERMS=`stat --printf='%a' "$TEST_WRITE_FILE"`
        rm -f "$TEST_WRITE_FILE"
        [ "$NEW_PERMS" == "1777" ] \
	    || continue
    else
        continue
    fi

    # check for free space
    MP_SPACE=$(echo `/bin/df "$destdir/$MP"| tail -n 1`| cut -d\  -f 4)
    if (($MP_SPACE > $BEST_SPACE)) ; then
	BEST_MP=$MP
	((BEST_SPACE=$MP_SPACE))
    fi
done < $destdir/etc/fstab

if (($BEST_SPACE > 0)) && [ -n "$BEST_MP" -a "$BEST_MP" != "/" -a ! -d "$destdir/$BEST_MP/tmp" ]
then

    # setup tmp mount point
    cp -ar $destdir/tmp "$destdir/$BEST_MP"/ ||:
    echo -e "$BEST_MP/tmp\t/tmp\tauto\tbind,rw,nosuid\t0\t0" >> $destdir/etc/fstab ||:
fi
